{% extends 'base.html' %}
{% load static %}
{% load extras %}

{% block css %}
    <link href="{% static 'css/filepond.css' %}" rel="stylesheet">
    {% if has_geo_field %}<link href="{% static 'css/leaflet/leaflet.css' %}" rel="stylesheet">{% endif %}
{% endblock %}

{% block modals %}
    <div class="modal fade" id="file-selection-modal" tabindex="-1" role="dialog" aria-labelledby="file-selection-modal-label" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="file-selection-modal-label">Select File</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="alert alert-light">
                        <div class="mb-2">
                            <input type="text" class="form-control" id="file-selection-modal-filter-box" aria-placeholder="Filter" placeholder="Filter">
                        </div>
                        <table class="table table-striped">
                            <thead class="thead-dark">
                                <th scope="col">Path: <span id="file-selection-modal-table-header">/</span></th>
                            </thead>
                            <tbody id="file-selection-modal-table-body">
                                <tr><td>Loading...</td></tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                        <input type="file" class="filepond">
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <div class="input-group">
                                <input type="text" class="form-control" id="file-selection-modal-new-folder-box" aria-placeholder="New Folder" placeholder="New Folder">
                                <span class="input-group-btn ml-1"><a href="javascript:handle_folder_creation();" role="button" id="file-selection-modal-new-folder-button" class="btn btn-secondary">Go</a></span>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="content-selection-modal" tabindex="-1" role="dialog" aria-labelledby="content-selection-modal-label" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="content-selection-modal-label">Select ContentType</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="alert alert-light">
                        <div class="mb-2">
                            <input type="text" class="form-control" id="content-selection-modal-filter-box" aria-placeholder="Search" placeholder="Search">
                        </div>
                        <table class="table table-striped">
                            <thead class="thead-dark">
                                <th scope="col" id="content-selection-modal-table-header">ContentType</th>
                            </thead>
                            <tbody id="content-selection-modal-table-body">
                                <tr><td>Loading...</td></tr>
                            </tbody>
                        </table>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" id="content-selection-modal-prev-page-button" class="btn btn-secondary"><span class="fas fa-angle-left"></span></button>
                    <button type="button" id="content-selection-modal-next-page-button" class="btn btn-secondary"><span class="fas fa-angle-right"></span></button>
                    <button type="button" id="content-create-new-button" class="btn btn-primary">Create New</button>
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

{% block main %}
    <div class="row flex-grow-1">
        <div class="col-12">
                    {% if content_ids or content_query %}
                        <div class="alert alert-info">
                            To set the value for a given field across your selected content, check the box to the left of that field's label.
                        </div>
                    {% endif %}
                    {% if edit_widget_url %}
                        <div class="row h-100">
                            <div class="col-sm-12 col-md-6">
                    {% endif %}
                    <form id="content-form" method="post">
                        {% csrf_token %}
                        <input type="hidden" name="corpora-content-edit" value="y">
                        {% if content_ids %}
                            <input type="hidden" id="content-ids-input" name="content-ids" value="{{ content_ids }}">
                        {% elif content_query %}
                            <input type="hidden" id="content-query-input" name="content-query" value=''>
                        {% endif %}
                    </form>
                    <div class="alert alert-info">
                        <button type="button" class="btn btn-primary" id="content-save-button">Save</button>
                        <button type="button" class="btn btn-primary" id="content-save-and-create-button">Save and Create New</button>
                        <a role="button" href="/corpus/{{ corpus_id }}/" class="btn btn-secondary">Cancel</a>
                    </div>
                    {% if edit_widget_url %}
                            </div>
                            <div class="col-sm-12 col-md-6">
                                <iframe id="edit-widget-iframe" src="" height="100%" width="100%" frameBorder="0"></iframe>
                            </div>
                        </div>
                    {% endif %}
                </div>
            </div>

        </div>
    </div>
{% endblock %}

{% block js %}
    <script src="{% static 'js/filepond.js' %}"></script>
    <script src="{% static 'js/tinymce/tinymce.min.js' %}"></script>
  {% if has_geo_field %}<script src="{% static 'js/leaflet.js' %}"></script>{% endif %}
    <script type="application/javascript">
        let corpus_id = '{{ corpus_id }}';
        let content_type = '{{ content_type }}';
        let content_id = '{% if content_id %}{{ content_id }}{% endif %}';
        let corpus = null;
        let content = null;
        let is_popup = {% if popup %}true{% else %}false{% endif %};
        let field_indexes = {};
        let multi_field_counter = 0;
        let bulk_editing = $('#content-ids-input').length || $('#content-query-input').length ? true : false;
        let bulk_edit_fields = [];
        {% if content_query %}
        let content_query = {{ content_query|safe }};
        {% endif %}

        let file_selection_input_id = null;
        let file_selection_path = '';
        let file_search_timer;
        let file_uploads = [];

        let content_selection_vars = {
            q: '*',
            only: 'label',
            s_label: 'asc',
            page_size: 10,
            page: 1
        };
        let content_search_timer;
        let content_selection_input_id = null;
        let content_selection_type = null;

        let latlong_timer = null;
        let map_markers = {};

        let input_templates = {
            text: function(field, value, id_suffix) {
                return `
                    <div id="${field.name}-value${id_suffix}-div" class="input-group mb-2 edit-field-div" data-field="${field.name}" data-index="${id_suffix}">
                        <textarea class="form-control edit-field-input ${field.name}-control" id="${field.name}-value${id_suffix}" rows="20" ${bulk_editing ? 'disabled' : ''}>${value}</textarea>
                        ${multi_remover(field, id_suffix)}
                    </div>
                `;
            },
            large_text: function(field, value, id_suffix) {
                return `
                    <div id="${field.name}-value${id_suffix}-div" class="input-group mb-2 edit-field-div" data-field="${field.name}">
                        <textarea class="form-control edit-field-input ${field.name}-control" id="${field.name}-value${id_suffix}" rows="20" ${bulk_editing ? 'disabled' : ''}>${value}</textarea>
                        ${multi_remover(field, id_suffix)}
                    </div>
                `;
            },
            keyword: function(field, value, id_suffix) {
                return `
                    <div id="${field.name}-value${id_suffix}-div" class="input-group mb-2 edit-field-div" data-field="${field.name}">
                        <input type="text" class="form-control edit-field-input ${field.name}-control" id="${field.name}-value${id_suffix}" value="${value}"  ${bulk_editing ? 'disabled' : ''}>
                        ${multi_remover(field, id_suffix)}
                    </div>
                `;
            },
            html: function(field, value, id_suffix) {
                return `
                    <div id="${field.name}-value${id_suffix}-div" class="input-group mb-2 edit-field-div" data-field="${field.name}">
                        <textarea id="${field.name}-value${id_suffix}" class="html-field edit-field-input ${field.name}-control" ${bulk_editing ? 'disabled' : ''}>
                            ${value}
                        </textarea>
                        ${multi_remover(field, id_suffix)}
                    </div>
                `;
            },
            number: function(field, value, id_suffix) {
                return `
                    <div id="${field.name}-value${id_suffix}-div" class="input-group mb-2 edit-field-div" data-field="${field.name}">
                        <input type="number" class="form-control edit-field-input ${field.name}-control" id="${field.name}-value${id_suffix}" value="${value}" ${bulk_editing ? 'disabled' : ''}>
                        ${multi_remover(field, id_suffix)}
                    </div>
                `;
            },
            decimal: function(field, value, id_suffix) {
                return `
                    <div id="${field.name}-value${id_suffix}-div" class="input-group mb-2 edit-field-div" data-field="${field.name}">
                        <input type="number" step="0.01" class="form-control edit-field-input ${field.name}-control" id="${field.name}-value${id_suffix}" value="${value}" ${bulk_editing ? 'disabled' : ''}>
                        ${multi_remover(field, id_suffix)}
                    </div>
                `;
            },
            boolean: function(field, value, id_suffix) {
                let is_true = false;
                if (['t', 'T', 'true', 'True', 1, true].includes(value)) { is_true = true; }
                return `
                    <div id="${field.name}-value${id_suffix}-div" class="form-check mb-2 edit-field-div" data-field="${field.name}">
                        <input class="form-check-input edit-field-input ${field.name}-control" type="checkbox" id="${field.name}-value${id_suffix}" ${is_true ? 'checked': ''}  ${bulk_editing ? 'disabled' : ''}>
                        <label class="form-check-label" for="${field.name}-value${id_suffix}">${field.label}</label>
                    </div>
                `;
            },
            date: function(field, value, id_suffix) {
                return `
                    <div id="${field.name}-value${id_suffix}-div" class="input-group mb-2 edit-field-div" data-field="${field.name}">
                        <input type="date" class="form-control edit-field-input ${field.name}-control" id="${field.name}-value${id_suffix}" value="${value ? corpora.date_string(value) : ''}"  ${bulk_editing ? 'disabled' : ''}>
                        ${multi_remover(field, id_suffix)}
                    </div>
                `;
            },
            file: function(field, value, id_suffix) {
                console.log(value);
                let sub_path = '';
                let multi_remove = '';

                if (value) {
                    sub_path = '/' + value.path.split('/').slice(7).join('/');
                }

                return `
                    <div id="${field.name}-value${id_suffix}-div" class="input-group mb-2 edit-field-div" data-field="${field.name}">
                        <div class="input-group-prepend">
                            <a href="javascript:select_file('${field.name}-value${id_suffix}');" role="button" class="btn btn-secondary" id="${field.name}-select-button">Browse</a>
                        </div>
                        <input type="text" class="form-control edit-field-input ${field.name}-control" id="${field.name}-value${id_suffix}" placeholder="File Path" aria-label="${field.label}" aria-describedby="${field.name}-select-button" value="${sub_path}">
                        ${multi_remover(field, id_suffix)}
                    </div>
                `;
            },
            link: function(field, value, id_suffix) {
                return `
                    <div id="${field.name}-value${id_suffix}-div" class="input-group mb-2 edit-field-div" data-field="${field.name}">
                        <input type="text" class="form-control edit-field-input ${field.name}-control" id="${field.name}-value${id_suffix}" value="${value}" ${bulk_editing ? 'disabled' : ''}>
                        ${multi_remover(field, id_suffix)}
                    </div>
                `;
            },
            'iiif-image': function(field, value, id_suffix) {
                return `
                    <div id="${field.name}-value${id_suffix}-div" class="input-group mb-2 edit-field-div" data-field="${field.name}">
                        <input type="text" class="form-control edit-field-input ${field.name}-control" id="${field.name}-value${id_suffix}" value="${value}" ${bulk_editing ? 'disabled' : ''}>
                        ${multi_remover(field, id_suffix)}
                    </div>
                `;
            },
            geo_point: function(field, value, id_suffix) {
                return `
                    <div id="${field.name}-value${id_suffix}-div" class="input-group mb-2 edit-field-div" data-field="${field.name}" style="flex-direction: column;">
                        <div class="row no-gutters">
                          <div class="col-sm-6">
                            <label for="${field.name}-value${id_suffix}-lat">Latitude</label>
                          </div>
                          <div class="col-sm-6">
                            <label for="${field.name}-value${id_suffix}-long">Longitude</label>
                          </div>
                        </div>
                        <div class="row no-gutters">
                          <div class="col-sm-6">
                            <input type="number" class="form-control ${field.name}-control" id="${field.name}-value${id_suffix}-lat" value="${value && value.length === 2 ? value[1] : ''}" ${bulk_editing ? 'disabled' : ''}>
                          </div>
                          <div class="col-sm-6">
                            <input type="number" class="form-control ${field.name}-control" id="${field.name}-value${id_suffix}-long" value="${value && value.length === 2 ? value[0] : ''}" ${bulk_editing ? 'disabled' : ''}>
                          </div>
                        </div>
                        <div class="row no-gutters">
                          <div id="${field.name}-value${id_suffix}-map" class="col-sm-12" style="height: 200px;">
                          </div>
                        </div>
                        <input type="hidden" id="${field.name}-value${id_suffix}" class="edit-field-input geo_point-input" value="${value && value.length === 2 ? value[0] + ',' + value[1] : ''}">
                        ${multi_remover(field, id_suffix)}
                    </div>
                `;
            },
            cross_reference: function(field, value, id_suffix) {
                let intensity_controls = ''
                if (field.has_intensity) {
                    intensity_controls = `
                        <div class="input-group ml-2">
                            <div class="input-group-prepend">
                                <span class="input-group-text" id="${field.name}-value${id_suffix}-intensity-label">Intensity</span>
                            </div>
                            <input type="number"
                                id="${field.name}-value${id_suffix}-intensity"
                                class="form-control edit-field-intensity" style="width: 100px;"
                                aria-label="Intensity for ${field.name} value"
                                aria-describedby="${field.name}-value${id_suffix}-intensity-label"
                                value="${value.hasOwnProperty('intensity') ? value.intensity : 1}">
                        </div>
                    `;
                }

                return `
                    <div id="${field.name}-value${id_suffix}-div" class="btn-toolbar mb-2 edit-field-div" data-field="${field.name}" role="toolbar">
                        <div class="btn-group" role="group">
                            <button onclick="return false;" id="${field.name}-value${id_suffix}-select-button" class="xref-select-button btn btn-secondary ${field.name}-control" ${bulk_editing ? 'disabled' : ''}>Select</button>
                            <button onclick="return false;" id="${field.name}-value${id_suffix}-open-button" class="xref-open-button btn btn-warning" role="button">${value ? value.label : `No ${field.cross_reference_type} selected.`}</button>
                            <button onclick="return false;" id="${field.name}-value${id_suffix}-clear-button" class="xref-clear-button btn btn-danger ${value ? '' : 'd-none'}" role="button">${field.multiple ? 'Delete' : 'Clear'}</button>
                        </div>${intensity_controls}
                        <input type="hidden" id="${field.name}-value${id_suffix}" class="edit-field-input" value="${value ? value.id : ""}">
                        <input type="hidden" id="${field.name}-value${id_suffix}-xref-type" value="${field.cross_reference_type}">
                    </div>
                `;
            }
        };

        const pond = FilePond.create(document.querySelector('.filepond'), {
            allowMultiple: true,
            allowRevert: false
        });

        pond.on('addfile', (error, file) => {
            if(!error) {
                file_uploads.push(file.filename);
            }
        });

        pond.on('processfile', (error, file) => {
            if(!error) {
                let index = file_uploads.indexOf(file.filename);
                if (index !== -1) { file_uploads.splice(index, 1); }
                if (file_uploads.length == 0) {
                    select_file(file_selection_input_id, file_selection_path);
                }
            }
        });

        $(document).ready(function() {
            corpora.get_corpus(corpus_id, function(corpus_data) {
                corpus = corpus_data;
                add_breadcrumb(corpus.name, `/corpus/${corpus_id}/`);
                build_content_form();

                {% if edit_widget_url %}
                $('#edit-widget-iframe').attr('src', '{{ edit_widget_url }}');
                {% endif %}

                if (bulk_editing) $('#content-save-and-create-button').addClass('d-none');

                if (is_popup) {
                    window.onunload = function() {
                        let opener = window.opener;
                        opener.refresh_content_selection();
                    };
                }
            });

            // SETUP FILE SEARCH BOX
            $('#file-selection-modal-filter-box').on('input', function(e){
                clearTimeout(file_search_timer);
                file_search_timer = setTimeout(function() {
                    let filter = $('#file-selection-modal-filter-box').val();
                    select_file(file_selection_function, file_selection_path, filter);
                }, 1200);
            });
        });

        function multi_remover(field, id_suffix, append=true) {
            if (field.multiple) {
                return `
                    <div class="${append ? 'input-group-append' : ''}">
                        <a href="javascript:remove_multi_field('${field.name}-value${id_suffix}-div');" role="button" class="btn btn-danger">Delete</a>
                    </div>
                `;
            }
            else {
                return '';
            }
        }

        function build_content_form() {
            let content_form = $("#content-form");

            for (let x = 0; x < corpus.content_types[content_type].fields.length; x++) {
                let field = corpus.content_types[content_type].fields[x];
                field_indexes[field.name] = x;

                if (field.type !== 'embedded') {
                    if (field.multiple) {
                        let label = `<label for="${field.name}-values-div">${field.label}</label>`;
                        if (field.type === 'boolean') { label = ''; }
                        content_form.append(`
                            ${bulk_editing ? `<input type="checkbox" class="bulk-edit-indicator" data-field="${field.name}">` : ''}
                            ${label}
                            <div class="ml-2 mb-2">
                                <div id="${field.name}-values-div" class="edit-field" data-field="${field.name}">
                                </div>
                                <button type="button" class="btn btn-sm btn-secondary add_multi_field_button ${field.name}-control" id="${field.name}-add-button" ${bulk_editing ? 'disabled' : ''}>Add</button>
                            </div>
                        `);
                    } else {
                        let label = `<label for="${field.name}-value">${field.label}</label>`;
                        if (field.type === 'boolean') { label = ''; }
                        content_form.append(`
                            <div id="${field.name}-value-div" class="form-group edit-field" data-field="${field.name}">
                                ${bulk_editing ? `<input type="checkbox" class="bulk-edit-indicator" data-field="${field.name}">` : ''} ${label}
                            </div>
                        `);
                    }
                }
            }

            if (content_id) {
                corpora.get_content(corpus_id, content_type, content_id, inject_content);
            } else {
                inject_content(null);
            }

            $('#content-save-button').click(function() {
                if (bulk_editing) {
                    $('.edit-field-div').each(function() {
                        if (!bulk_edit_fields.includes($(this).data('field'))) {
                            $(this).remove();
                        }
                    });
                }
                bundle_content();
                let content_form = $('#content-form');
                content_form.submit();
            });

            $('#content-save-and-create-button').click(function() {
                let content_form = $('#content-form');
                content_form.append('<input type="hidden" name="save-and-create" value="y" />');
                bundle_content();
                content_form.submit();
            });

            $('.add_multi_field_button').click(function() {
                let field_name = this.id.replace('-add-button', '');
                let field = corpus.content_types[content_type].fields[field_indexes[field_name]];

                $(`#${field.name}-values-div`).append(input_templates[field.type](field, '', `-${multi_field_counter}`));
                if (bulk_edit_fields.includes(field_name)) {
                    $(`.${field_name}-control`).attr('disabled', false);
                }

                if (field.type === 'html') {
                    tinymce.init(
                        {
                            selector: `#${field.name}-value-${multi_field_counter}`,
                            plugins: 'link code table',
                            menubar: 'edit insert view format table tools help'
                        }
                    );
                } else if (field.type === 'cross_reference') {
                    assign_content_selection_events();
                } else if (field.type === 'geo_point') setup_geo_inputs();
                multi_field_counter += 1;
            });
        }

        function inject_content(content_data) {
            content = content_data;
            let page_title = $('#page-title');
            let has_html_field = false;
            let has_file_field = false;
            let has_xref_field = false;
            let has_geo_field = {% if has_geo_field %}true{% else %}false{% endif %};

            if (bulk_editing) {
                page_title.html(`Bulk Editing ${content_type}(s)`);
            } else if (!content) {
                page_title.html(`New ${content_type}`);
            } else {
                page_title.html(content.label);
                add_breadcrumb(content.label, `/corpus/${corpus_id}/${content_type}/${content_id}/`);
            }

            for (let f_index = 0; f_index < corpus.content_types[content_type].fields.length; f_index++) {
                let field = corpus.content_types[content_type].fields[f_index];

                if (field.type === 'html') { has_html_field = true; }
                else if (field.type === 'file') { has_file_field = true; }
                else if (field.type === 'cross_reference') { has_xref_field = true; }

                if (field.type !== 'embedded') {
                    if (field.multiple) {
                        if (content && content[field.name]) {
                            content[field.name].forEach(function (value, index) {
                                $(`#${field.name}-values-div`).append(input_templates[field.type](field, value, `-${index}`));
                                multi_field_counter += 1;
                            });
                        }
                    } else if (content) {
                        $(`#${field.name}-value-div`).append(input_templates[field.type](field, content[field.name] ? content[field.name] : "", ""));
                    } else {
                        $(`#${field.name}-value-div`).append(input_templates[field.type](field, "", ""));
                    }
                }
            }

            if (has_html_field) {
                tinymce.init(
                    {
                        selector: '.html-field',
                        plugins: 'link code table',
                        menubar: 'edit insert view format table tools help',
                    }
                );

                if (bulk_editing) { tinymce.activeEditor.mode.set("readonly"); }
            }

            if (has_xref_field) {
                assign_content_selection_events();
            }

            if (has_geo_field) {
                setup_geo_inputs();
            }

            if (bulk_editing) {
                $('.bulk-edit-indicator').change(function() {
                    let field_name = $(this).data('field');

                    if (Object.keys(field_indexes).includes(field_name)) {
                        let field = corpus.content_types[content_type].fields[field_indexes[field_name]];

                        if (this.checked) {
                            $(`.${field_name}-control`).attr('disabled', false);
                            if (field.type === 'html') tinymce.activeEditor.mode.set("design");
                            bulk_edit_fields.push(field_name);
                        } else {
                            $(`.${field_name}-control`).attr('disabled', true);
                            if (field.type === 'html') tinymce.activeEditor.mode.set("readonly");
                            bulk_edit_fields = bulk_edit_fields.filter(e => e !== field_name);
                        }
                    }
                });

                if (typeof content_query !== 'undefined') {
                    $('#content-query-input').val(JSON.stringify(content_query));
                }
            }

            hide_loading_overlay();
        }

        function setup_geo_inputs() {
            let geo_point_inputs = $('.geo_point-input');

            geo_point_inputs.each(function() {
                let geo_point_input = $(this);
                let id_prefix = geo_point_input[0].id;
                let lat_input = $(`#${id_prefix}-lat`);
                let long_input = $(`#${id_prefix}-long`);
                let map = L.map(`${id_prefix}-map`);

                L.tileLayer('https://tile.openstreetmap.org/{z}/{x}/{y}.png', {
                    maxZoom: 19,
                    attribution: '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>'
                }).addTo(map);

                const set_marker = (lat_input, long_input, geo_point_input, map) => {
                    let lat = parseFloat(lat_input.val());
                    let long = parseFloat(long_input.val());
                    let reset_view = false;

                    while (lat < -90) {
                        lat += 180;
                        reset_view = true;
                    }
                    while (lat > 90) {
                        lat -= 180;
                        reset_view = true;
                    }
                    while (long < -180) {
                        long += 360;
                        reset_view = true;
                    }
                    while (long > 180) {
                        long -= 360;
                        reset_view = true;
                    }

                    let coords = [lat, long];

                    let last_marker_id = geo_point_input.data('marker');
                    if (last_marker_id) {
                        map.removeLayer(map_markers[last_marker_id]);
                        delete map_markers[last_marker_id];
                    }
                    let marker = L.marker(coords);
                    marker.addTo(map);
                    map_markers[marker._leaflet_id] = marker;
                    geo_point_input.data('marker', marker._leaflet_id);
                    geo_point_input.val(`${long_input.val()},${lat_input.val()}`);
                    if (reset_view) map.setView(coords, 13);
                    return coords;
                };

                if (lat_input.val() && long_input.val()) {
                    let coords = set_marker(lat_input, long_input, geo_point_input, map);
                    map.setView(coords, 13);
                } else
                    map.locate({setView: true});

                map.on('click', function(e) {
                    lat_input.val(e.latlng.lat);
                    long_input.val(e.latlng.lng);
                    let coords = set_marker(lat_input, long_input, geo_point_input, map);
                    lat_input.val(coords[0]);
                    long_input.val(coords[1]);
                });

                $(`#${id_prefix}-lat, #${id_prefix}-long`).on('change paste keyup', function() {
                    clearTimeout(latlong_timer);
                    latlong_timer = setTimeout(function() {
                        set_marker(lat_input, long_input, geo_point_input, map);
                    }, 1000);
                });

                geo_point_input.removeClass('geo_point-input');
            });
        }

        function bundle_content() {
            let bundle = {};

            $('.edit-field').each(function() {
                let div = $(this);
                let field_name = div.data('field');
                if (Object.keys(field_indexes).includes(field_name)) {
                    let field = corpus.content_types[content_type].fields[field_indexes[field_name]];
                    if (field.multiple) bundle[field_name] = [];

                    div.find('.edit-field-input').each(function() {
                        let input = $(this);
                        let data = {};

                        if (field.type === 'boolean') data['value'] = input.is(':checked');
                        else if (field.type === 'html') data['value'] = tinymce.get(input[0].id).getContent();
                        else if (field.type === 'number') data['value'] = parseInt(input.val());
                        else if (field.type === 'decimal') data['value'] = parseFloat(input.val());
                        else if (field.type === 'geo_point' && input.val()) {
                            let longlat_strs = input.val().split(',');
                            data['value'] = [parseFloat(longlat_strs[0]), parseFloat(longlat_strs[1])];
                        } else data['value'] = input.val();

                        if (field.has_intensity) {
                            let intensity_input = $(`#${input[0].id}-intensity`);
                            if (intensity_input.length) data['intensity'] = intensity_input.val();
                        }

                        if (field.multiple) bundle[field_name].push(data);
                        else bundle[field_name] = data;
                    });
                }
            });

            console.log(bundle);
            $('#content-form').append(`
                <input type="hidden" id="content-bundle" name="content-bundle">
            `);
            $('#content-bundle').val(JSON.stringify(bundle));
        }

        function remove_multi_field(div_id) {
            $(`#${div_id}`).remove();
        }

        // FILE SELECTION FUNCTIONALITY
        function select_file(input_id, path='', filter='', select='file') {
            corpora.get_content_files(corpus_id, content_type, content_id, path, filter, function (data) {
                file_selection_input_id = input_id;
                file_selection_path = path;

                let url = `/api/corpus/${corpus_id}/${content_type}/files/`;
                if (content_id) {
                    url = url.replace('/files/', `/${content_id}/files/`)
                }

                pond.setOptions({
                    server: {
                        process: {
                            url: `${url}?path=${path}`,
                            headers: {
                                'X-CSRFToken': '{{ csrf_token }}'
                            }
                        },
                        fetch: null,
                        revert: null
                    }
                });
                pond.removeFiles();
                file_uploads = [];

                $('#file-selection-modal-table-body').html('');
                $('#file-selection-modal-table-header').html(path + '/');
                if (path) {
                    let up_directory = '/' + path.split('/').slice(1, -1).join('/');
                    if (up_directory === '/') { up_directory = ''; }
                    if (select === 'file') {
                        $('#file-selection-modal-table-header').append(`<a href="javascript:select_file(file_selection_input_id, '${up_directory}');" style="color: white;"><span class="fas fa-level-up-alt float-right"></span></a>`);
                    } else {
                        $('#file-selection-modal-table-header').append(`<a href="javascript:select_file(file_selection_input_id, '${up_directory}', '', 'dir');" style="color: white;"><span class="fas fa-level-up-alt float-right"></span></a>`);
                    }
                }
                for (let x = 0; x < data.length; x++) {
                    if(select === 'file') {
                        if (data[x].type === 'file') {
                            $('#file-selection-modal-table-body').append(`
                                <tr><td><a href="javascript:handle_file_selection('${data[x].path}', '${data[x].filename}');">${data[x].filename}</a></td></tr>
                            `);
                        } else {
                            $('#file-selection-modal-table-body').append(`
                                <tr><td><span class="fas fa-folder-open"></span> ${data[x].filename} <a class="btn btn-sm btn-primary text-white float-right" role="button" href="javascript:select_file(file_selection_input_id, '${data[x].path}');">Browse</a></td></tr>
                            `);
                        }
                    } else {
                        if (data[x].type === 'dir') {
                            $('#file-selection-modal-table-body').append(`
                                <tr><td><span class="fas fa-folder-open"></span> <a href="javascript:handle_file_selection('${data[x].path}', '');">${data[x].filename}</a> <a class="btn btn-sm btn-primary text-white float-right" role="button" href="javascript:select_file(file_selection_input_id, '${data[x].path}', '', 'dir');">Browse</a></td></tr>
                            `);
                        }
                    }
                }

                $('#file-selection-modal').modal();
            });
        }

        function handle_folder_creation() {
            let dirname = pep8_variable_format($('#file-selection-modal-new-folder-box').val());
            corpora.make_content_file_dir(corpus_id, content_type, content_id, file_selection_path, dirname, function() {
                $('#file-selection-modal-new-folder-box').val('');
                select_file(file_selection_input_id, path=file_selection_path);
            });
        }

        function handle_file_selection(path, filename) {
            $(`#${file_selection_input_id}`).val(`${path}/${filename}`);
            $('#file-selection-modal').modal('hide');
        }

        // CONTENT SELECTION FUNCTIONALITY
        function select_content(ct, input_id) {
            content_selection_input_id = input_id;
            content_selection_type = ct;

            corpora.list_content(corpus_id, content_selection_type, content_selection_vars, function(data){
                $('#content-selection-modal-prev-page-button').prop('disabled', content_selection_vars.page <= 1);
                $('#content-selection-modal-next-page-button').prop('disabled', !data.meta.has_next_page);

                $('#content-selection-modal-label').html(`Select ${content_selection_type}`);
                $('#content-selection-modal-table-header').html(content_selection_type);
                $('#content-selection-modal-table-body').html('');
                for (let x = 0; x < data.records.length; x++) {
                    $('#content-selection-modal-table-body').append(`
                        <tr><td><a id="xref-item-${data.records[x].id}" href="javascript:handle_content_selection('${data.records[x].id}');">${data.records[x].label}</a></td></tr>
                    `);
                }

                // SETUP CONTENT CREATE NEW BUTTON
                let new_button = $('#content-create-new-button');
                new_button.off('click'); // <- removes previously associated click events
                new_button.click(function() {
                    let left = (screen.width / 2);
                    let top = (screen.height / 2);
                    let options = `top=${top},left=${left},popup=true`;
                    let creation_url = `/corpus/${corpus_id}/${content_selection_type}/?popup=y`;
                    return window.open(creation_url, '_blank', options);
                });

                $('#content-selection-modal').modal();
            });
        }

        function assign_content_selection_events() {
            // select content button click event
            $('.xref-select-button').click(function() {
                let button_id = this.id;
                let input_id = button_id.replace('-select-button', '');
                let xref_type = $(`#${input_id}-xref-type`).val();

                content_selection_vars = {
                    q: '*',
                    only: 'label',
                    s_label: 'asc',
                    page_size: 10,
                    page: 1
                };
                $('#content-selection-modal-filter-box').val('');
                select_content(xref_type, input_id);
            });

            // content navigation button click event
            $('.xref-open-button').click(function() {
                let button_id = this.id;
                let input_id = button_id.replace('-open-button', '');
                let xref_type = $(`#${input_id}-xref-type`).val();
                let xref_id = $(`#${input_id}`).val();

                if (xref_id) {
                    window.open(`/corpus/${corpus_id}/${xref_type}/${xref_id}/`, '_blank');
                }
            });

            // content clear button click event
            $('.xref-clear-button').click(function() {
                let button_id = this.id;
                let input_id = button_id.replace('-clear-button', '');
                let xref_type = $(`#${input_id}-xref-type`).val();

                // single value
                if(input_id.split('-').length === 2) {
                    $(`#${input_id}`).val('');
                    $(`#${input_id}-clear-button`).addClass('d-none');
                    $(`#${input_id}-open-button`).html(`No ${xref_type} selected.`);
                } else {
                    $(`#${input_id}-div`).remove();
                }
            });
        }

        // content selection filter box
        $('#content-selection-modal-filter-box').keypress(function (e) {
            let key = e.which;
            if (key === 13) {
                refresh_content_selection();
            }
        });

        function refresh_content_selection() {
            let query = $('#content-selection-modal-filter-box').val();
            content_selection_vars.q = query;
            select_content(content_selection_type, content_selection_input_id);
        }

        // previous select content page click event
        $('#content-selection-modal-prev-page-button').click(function() {
            content_selection_vars.page -= 1;
            select_content(content_selection_type, content_selection_input_id);
        });

        // next select content page click event
        $('#content-selection-modal-next-page-button').click(function() {
            content_selection_vars.page += 1;
            select_content(content_selection_type, content_selection_input_id);
        });

        function handle_content_selection(id) {
            let label = $(`#xref-item-${id}`).html();

            $(`#${content_selection_input_id}`).val(id);
            $(`#${content_selection_input_id}-open-button`).html(label);
            $(`#${content_selection_input_id}-clear-button`).removeClass('d-none');
            $('#content-selection-modal').modal('hide');
        }

    </script>
{% endblock %}